/* 
 * Copyright (C) 2000  Florian Sander
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/* stolen from tcl_duration in tclmisc.c */
char duration_temp[256];
static char *duration(int seconds)
{
  char s[256];
  time_t sec;

  Context;
  sec = seconds;
  s[0] = 0;

  if (sec < 1) {
    sprintf(duration_temp, "0 seconds");
    return duration_temp;
  }
  if (sec >= 31536000) {
    sprintf(s, "%d year", (int) (sec / 31536000));
    if ((int) (sec / 31536000) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 31536000)) * 31536000);
  }
  if (sec >= 604800) {
    sprintf(&s[strlen(s)], "%d week", (int) (sec / 604800));
    if ((int) (sec / 604800) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 604800)) * 604800);
  }
  if (sec >= 86400) {
    sprintf(&s[strlen(s)], "%d day", (int) (sec / 86400));
    if ((int) (sec / 86400) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 86400)) * 86400);
  }
  if (sec >= 3600) {
    sprintf(&s[strlen(s)], "%d hour", (int) (sec / 3600));
    if ((int) (sec / 3600) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 3600)) * 3600);
  }
  if (sec >= 60) {
    sprintf(&s[strlen(s)], "%d minute", (int) (sec / 60));
    if ((int) (sec / 60) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 60)) * 60);
  }
  if (sec > 0) {
    sprintf(&s[strlen(s)], "%d second", (int) (sec / 1));
    if ((int) (sec / 1) > 1)
      strcat(s, "s");
  }
  sprintf(duration_temp, "%s", s);
  Context;
  return duration_temp;
}

static int countsmileys(char *text)
{
  char buf[512], *pbuf, *smiley, *p;
  int ismileys = 0;

  sprintf(buf, "%s", smileys);
  pbuf = buf;
  while (strlen(pbuf) > 0) {
    smiley = newsplit(&pbuf);
    p = strstr(text, smiley);
    while (p) {
      ismileys++;
      p += strlen(smiley);
      p = strstr(p, smiley);
    }
  }
  return ismileys;
}

static int countstatmembers(globstats *gs)
{
  int members = 0;
  struct userrec *u;
  locstats *ls;

  Context;
  for (ls = gs->local; ls; ls = ls->next) {
    u = get_user_by_handle(userlist, ls->user);
    if (matchattr(u, nostats, gs->chan))
      continue;
    members++;
  }
  return members;
}

static int gettotal(globstats *gs, int type, int today)
{
  int total = 0;
  struct userrec *u;
  locstats *ls;
  
  Context;
  for (ls = gs->local;ls; ls = ls->next) {
    u = get_user_by_handle(userlist, ls->user);
    if (matchattr(u, nostats, gs->chan))
      continue;
    total += ls->values[today][type];
  }
  Context;
  return total;
}

/* stolen from tcl_matchattr */
static int matchattr (struct userrec *u, char *flags, char *chan) {
  struct flag_record plus, minus, user;
  int ok = 0, f;

  Context;
#ifndef OLDBOT
  if (u && (!chan || findchan_by_dname(chan))) {
#else
  if (u && (!chan || findchan(chan))) {
#endif
    Context;
    user.match = FR_GLOBAL | (chan ? FR_CHAN : 0) | FR_BOT;
    get_user_flagrec(u, &user, chan);
    plus.match = user.match;
    break_down_flags(flags, &plus, &minus);
    f = (minus.global || minus.udef_global || minus.chan ||
   minus.udef_chan || minus.bot);
    if (flagrec_eq(&plus, &user)) {
      Context;
      if (!f)
  ok = 1;
      else {
  minus.match = plus.match ^ (FR_AND | FR_OR);
  if (!flagrec_eq(&minus, &user))
    ok = 1;
      }
    }
  }
  Context;
  return ok;
}

static int countwords(char *buf)
{
  int i, words = 1;

  for (i = 0; i < strlen(buf); i++) {
    if ((buf[i] == ' ') && (buf[i+1] != ' '))
      words++;
  }
  return words;
}

char *splitpath(char **rest)
{
  register char *o, *r;

  if (!rest)
    return *rest = "";
  o = *rest;
  while (*o == ' ')
    o++;
  r = o;
  while (*o && (*o != '/'))
    o++;
  if (*o)
    *o++ = 0;
  *rest = o;
  return r;
}

static void filt(char *text)
{
  int i;
  
  Context;
  for (i = 0; i < strlen(text); i++)
    if (text[i] == '%')
      text[i] = ' ';
}